# ------------------------------------------------------------ #
# ------- APERTURA DE FICHEROS CON CONTROL DE ERRORES -------- #
# -- Input:  fichero: nombre del fichero 				-- #
# --         modo: modo de apertura					-- #
# --	Output: error: vale TRUE si no se abre el fichero 	-- #
# --		  conexion: conexin 					-- #
# ------------------------------------------------------------ #
open_file=function(fichero,modo="r+"){
	if(!file.exists(fichero)){	# no se encuentra el fichero
		cat("No se encuentra el fichero",fichero,"\n")
		return(list("error"=TRUE))}
	else{
		con=try(file(fichero,open=modo),silent=T)
		while(any(class(con)=="try-error")){
			Sys.sleep(1)
			con=try(file(fichero,open=modo),silent=T)}
		if(any(class(con)=="try-error")){			#error al abrir el fichero
			cat("Error al abrir el fichero",fichero,"\n")
			return(list("error"=TRUE))}
		else{
			return(list("conexion"=con,"error"=FALSE))}}}
# ------------------------------------------------------------ #
# --------- FORMATO DE UN VECTOR NUMRICO O CARCTER --------- #
# -- Input: v: vector al que dar formato 				-- #
# --        form: n de caracteres por componente de v 	-- #
# --        dec: n de decimales por componente de v 		-- #
# -- Output: v: vector formateado 					-- #
# ------------------------------------------------------------ #
formato=function(v,form=9,dec=0){
	if(is.numeric(v)){
		v=round(v,as.integer(dec))
		v=format(v,justify="right",width=form,nsmall=dec)}
	else{
		v[form-nchar(v)<0]=substr(v[form-nchar(v)<0],1,form)
		v=format(v,justify="right",width=form)}
	return(v)}

# ------------------------------------------------------------ #
# ---------------- FORMATO DE FECHAS POSIXlt ----------------- #
# -- Pasa fechas en formato c(aa,mm,dd,hh,mm) a formato 	-- #
# -- POSIXlt (si opcion=T) y viceversa (si opcion=F) 		-- #
# ------------------------------------------------------------ #
fechaPOSIX=function(fecha,opcion=T){
	if(opcion){
		if(is.null(dim(fecha))) fecha=matrix(fecha,1,length(fecha))
		fecha=as.POSIXlt(paste(paste(fecha[,1],fecha[,2],fecha[,3],sep="-"),
						paste(fecha[,4],fecha[,5],sep=":")))}
	else{
		fecha=cbind(fecha$year+1900,fecha$mon+1,fecha$mday,fecha$hour,fecha$min)}
	return(fecha)}
