# ------------------------------------------------------------ #
# ------------ PREDICCIN ESTADSTICA DE INMISIN ------------ #
# ---------- datos recogidos de la aplicacin MEDAS ---------- #
# -------- CONFIGURACIN DE VALORES: configuracion.txt ------- #
# ------------------------------------------------------------ #
#Series de fechas (incluyen predicciones)
# fecha (POSIXlt):		fechaP[n_long+n_pred]
# fecha (character):		fecha[n_long+n_pred,dim_fecha]
#Series de datos reales
# inmisin (numeric):		inmi_real[n_long,n_inm,n_est]
# inmisin (character):		finmision[n_long,(n_inm+8),n_est]
# emisin (numeric):		emi_real[n_long,n_emi,n_grupo]
# emisin (character):		femision[n_long,n_grupo*n_emi]
# emisin_cc (numeric):		emicc_real[n_long,n_emicc,n_grupocc]
# emisin_cc (character):	femisioncc[n_long,n_grupocc*n_emicc]
# mourela (numeric):		mourela[n_long,n_mourela]
# mourela (character):		fmourela[n_long,n_mourela]
#Series de medias horarias de datos reales de inmisin
# media horaria (numeric):	inmi_medH[n_long,n_inm,n_est]
#Series de predicciones inmisin
# prediccin media horaria (numeric):	inmi_predMH[n_long+n_pred,n_inm,n_est]
# prediccin binaria (numeric):		pred_bin[n_long+n_pred,n_inm,n_est]
#Cdigos alarmas
# lmites para los mensajes:	lim_men[n_mensaje+1]
# cdigos de mensajes:		mensaje_texto[n_mensaje+1]
# serie de mensajes:		mensaje[n_long+n_pred,n_est]
#Cdigos para datos missing
# inmisin missing:		inmi_miss[n_inm]
# emisin missing:		emi_miss[n_emi]
# emisin_cc missing:		emicc_miss[n_emi]
# mourela missing:		mour_miss[n_mourela]
# mensaje missing:		mensaje_miss
#Directorios para ficheros
# directorios de destino:		dir_dest[n_dest]
# directorio de configuraciones:	direc_conf
# directorio de origen de datos:	direc_datos
#Nombres de estaciones y variables
# estaciones:				est_nombre[n_est]
# grupos:					grupo_nombre[n_grupo]
# grupos_cc:				grupocc_nombre[n_grupocc]
# variables inmisin:			inm_nombre[n_inm]
# variables emisin:			emi_nombre[n_emi]
# variables emisin_cc:			emicc_nombre[n_emicc]
# variables mourela:			mour_nombre[n_mourela]
#Nombres de ficheros histricos creados en el programa
# his1_fich: nombre fichero histrico de inmisin
# his2_fich: nombre fichero histrico de prediccin
# his3_fich: nombre fichero histrico de emisin
# his4_fich: nombre fichero histrico de emisin ciclo combinado
# his5_fich: nombre fichero histrico de meteorologa
# ------------------------------------------------------------ #
MEDAS_5min=function(){
	cat(rep("-",55),"\n\t\t\tSIPEI","\n\t  Configuracin Datos Pentaminutales\n",rep("-",55),"\n",sep="")
# Leer fichero de configuracin (fichero de texto en directorio de programa)
	t0=Sys.time()
	fichero="configuracion.txt"
	if (!file.exists(fichero)) stop("No encuentra configuracion.txt\nEjecucin de predESTADmin finalizada\n")
	abrir=open_file(fichero)	
	n_long=scan(abrir$con,n=1,skip=3,nlines=1,quiet=T)			#Longitud de las series reales
	n_est=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N de estaciones de la red de inmisin
	n_grupo=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N de grupos de emisin
	n_grupocc=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N de grupos de emisin ciclo combinado
	n_inm=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N variables de estaciones de inmisin
	n_emi=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N variables de emisin
	n_emicc=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N variables de emisin ciclo combinado	
	n_mourela=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N variables de estacin meteorolgica de Mourela
	dim_fecha=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N variables de la fecha: Ao,Mes,Da,Hora,Minuto
	direc_datos=scan(abrir$con,what="",sep="\n",n=1,skip=1,nlines=1,strip.white=T,quiet=T)	#Directorio de origen de datos
	n_dest=scan(abrir$con,n=1,skip=1,nlines=1,quiet=T)			#N de directorios de destino para las predicciones
	dir_dest=scan(abrir$con,what="",sep="\n",n=1,skip=1,nlines=n_dest,strip.white=T,quiet=T)	#Directorios de destino
	datos_fich=scan(abrir$con,what="",n=1,skip=1,nlines=1,quiet=T)	#Nombre del fichero de datos de MEDAS
	fecha_fich=scan(abrir$con,what="",n=1,skip=1,nlines=1,quiet=T) 	#Nombre fichero de fecha actual
	emi_fich=scan(abrir$con,what="",n=1,skip=1,nlines=1,quiet=T)	#Nombre fichero de emisin
	emicc_fich=scan(abrir$con,what="",n=1,skip=1,nlines=1,quiet=T)	#Nombre fichero de emisin ciclo combinado	
	est_fich=scan(abrir$con,what="",n=1,skip=1,nlines=1,quiet=T)	#Encabezado nombre ficheros de estaciones
	est_nombre=scan(abrir$con,what="",n=n_est,skip=1,nlines=1,quiet=T)		#Nombres de estaciones
	grupo_nombre=scan(abrir$con,,what="",sep="\t",n=n_grupo,skip=1,nlines=1,quiet=T)	#Nombres de grupos
	grupocc_nombre=scan(abrir$con,,what="",sep="\t",n=n_grupo,skip=1,nlines=1,quiet=T)	#Nombres de grupos ciclo combinado
	inm_nombre=scan(abrir$con,what="",n=n_inm,skip=1,nlines=1,quiet=T)		#Nombres de variables de inmisin
	emi_nombre=scan(abrir$con,what="",n=n_emi,skip=1,nlines=1,quiet=T)		#Nombres de variables de emisin
	emicc_nombre=scan(abrir$con,what="",n=n_emicc,skip=1,nlines=1,quiet=T)		#Nombres de variables de emisin ciclo combinado
	mour_nombre=scan(abrir$con,what="",n=n_mourela,skip=1,nlines=1,quiet=T)		#Nombres de variables de Mourela
	inmi_miss=scan(abrir$con,n=n_inm,skip=1,nlines=1,quiet=T)		#Valores missing de inmisin
	emi_miss=scan(abrir$con,n=n_emi,skip=1,nlines=1,quiet=T)		#Valores missing de emisin
	emicc_miss=scan(abrir$con,n=n_emicc,skip=1,nlines=1,quiet=T)	#Valores missing de emisin ciclo combinado
	mour_miss=scan(abrir$con,n=n_mourela,skip=1,nlines=1,quiet=T)	#Valores missing de mourela
	close(abrir$con)
# Inicializar las variables numeric
	fechaP=rep(fechaPOSIX(c(2000,1,1,0,0)),n_long)
	inmi_real=array(rep(inmi_miss,each=n_long),c(n_long,n_inm,n_est),
		dimnames=list(NULL,formato(inm_nombre,9),est_nombre))
	inmi_medH=array(rep(inmi_miss,each=n_long),c(n_long,n_inm,n_est),
		dimnames=list(NULL,formato(paste(inm_nombre,"_MH",sep=""),9),est_nombre))
	emi_real=array(rep(emi_miss,each=n_long),c(n_long,n_emi,n_grupo),
		dimnames=list(NULL,formato(emi_nombre,9),formato(grupo_nombre,9)))
	emicc_real=array(rep(emicc_miss,each=n_long),c(n_long,n_emicc,n_grupocc),
		dimnames=list(NULL,formato(emicc_nombre,9),formato(grupocc_nombre,9)))
# Inicializar las variables character
	fecha=formato(fechaPOSIX(fechaP,F),5,0)
	dimnames(fecha)=list(NULL,formato(c("Ao","Mes","Da","Hora","Min"),5))
	finmision=array(matrix(rep(formato(c(inmi_miss,inmi_miss[1:6]),9,2),n_long),n_long,n_inm+6,byrow=T),
			c(n_long,n_inm+6,n_est))
	dimnames(finmision)=list(NULL,c(dimnames(inmi_real)[[2]],dimnames(inmi_medH)[[2]][1:6]),dimnames(inmi_real)[[3]])
	femision=matrix(formato(emi_miss,9,2),n_long,n_emi*n_grupo,byrow=T,
		dimnames=list(NULL,rep(dimnames(emi_real)[[2]],n_grupo)))
	femisioncc=matrix(formato(emicc_miss,9,2),n_long,n_emicc*n_grupocc,byrow=T,
		dimnames=list(NULL,rep(dimnames(emicc_real)[[2]],n_grupocc)))
# Cambiar a directorio de datos
	setwd(direc_datos)
# Leer fecha actual
	aux=leer_matriz(fecha_fich,0,1,dim_fecha)
	if (aux$error){
		cat("Error al leer fecha_actual\n")
		aux$datos=c(2000,1,1,0,0)}
	fecha_actual=fechaPOSIX(aux$datos)
# Leer ficheros cincominutales con medias horarias y predicciones
    for(i in 1:n_est){  #leer los ltimos n_long=48 datos cincominutales de cada estacin
        fichero=paste(est_fich,est_nombre[i],".dat",sep="")
        aux=leer_matriz(fichero,1,n_long,(dim_fecha+n_inm+6))
        if(!aux$error){
            fechaP=fechaPOSIX(aux$datos[,1:dim_fecha])
            inmi_real[,,i]=aux$datos[,(dim_fecha+1):(dim_fecha+n_inm)]
            inmi_medH[,1:6,i]=aux$datos[,(dim_fecha+n_inm+1):(dim_fecha+n_inm+6)]
            fecha[,]=formato(fechaPOSIX(fechaP,F),5)
            finmision[1:n_long,1:(n_inm+6),i]=formato(cbind(inmi_real[,,i],inmi_medH[,1:6,i]),9,2)}}
# Leer datos de emisin
	aux=leer_matriz(emi_fich,1,n_long,dim_fecha+(n_emi-3)*n_grupo)
	ind_emi=c(1,2,3,5)
	if(!aux$error){
		fechaP[1:n_long]=fechaPOSIX(aux$datos[,1:dim_fecha])
		emi_real[,ind_emi,]=aux$datos[,-(1:dim_fecha)]
		fecha[1:n_long,]=formato(fechaPOSIX(fechaP[1:n_long],F),5)
		femision[,as.numeric(outer(ind_emi,n_emi*0:(n_grupo-1),"+"))]=formato(emi_real[,ind_emi,],9,2)}
# Leer datos de emisin del ciclo combinado
	aux=leer_matriz(emicc_fich,1,n_long,dim_fecha+(n_emicc-6)*n_grupocc)
	ind_emicc=c(1,2,3,8)
	if(!aux$error){
		fechaP[1:n_long]=fechaPOSIX(aux$datos[,1:dim_fecha])
		emicc_real[,ind_emicc,]=aux$datos[,-(1:dim_fecha)]
		fecha[1:n_long,]=formato(fechaPOSIX(fechaP[1:n_long],F),5)
		femisioncc[,as.numeric(outer(ind_emicc,n_emicc*0:(n_grupocc-1),"+"))]=formato(emicc_real[,ind_emicc,],9,2)}
cat("Lectura de datos iniciales (",round(difftime(Sys.time(),t0,units="secs"),4),"s )\n")
flush.console()
# ------------------------------------------------------------
# Bucle Infinito
# ------------------------------------------------------------
tiempo=0	#la primera vez no espera
while(TRUE){
	cat("Esperando datos nuevos...\n")
	flush.console()
	Sys.sleep(tiempo)
	tiempo=150
# Cambiar a directorio de datos
	setwd(direc_datos)
# Leer datos de aplicacin
	aux=lee_datosnuevos(datos_fich,dim_fecha,n_inm,n_est-4,n_emi,n_grupo,n_emicc+1,n_grupocc,n_mourela,inmi_miss,emi_miss,emicc_miss,mour_miss)
		if(!aux$error){		# regresa al inicio del bucle si no ha ledo el fichero completo.
			fecha_nueva=aux$fecha
			inmi_nuevo=aux$datos1
			emi_nuevo=aux$datos2
			emicc_nuevo=aux$datos3
	# Clculos si hay datos nuevos
		if (fecha_actual<fecha_nueva){
			t0=Sys.time()
			cat("\tCalculando para fecha",format(fecha_nueva,"%d/%m/%y %H:%M "))
			flush.console()
		# calculo instantes a atrasar (si son ms de 4 horas, he perdido los datos)
			n_instante=min(as.numeric(difftime(fecha_nueva,fecha_actual,units="mins"))/5,n_long-1)
		# actualizo la fecha
			fecha_actual=fecha_nueva
		# Atrasar las series el nmero de instantes correspondientes
			fechaP[1:(n_long-n_instante)]=fechaP[(1+n_instante):n_long]
			inmi_real[1:(n_long-n_instante),,]=inmi_real[(1+n_instante):n_long,,]
			inmi_medH[1:(n_long-n_instante),,]=inmi_medH[(1+n_instante):n_long,,]
			emi_real[1:(n_long-n_instante),,]=emi_real[(1+n_instante):n_long,,]
			emicc_real[1:(n_long-n_instante),,]=emicc_real[(1+n_instante):n_long,,]
			fecha[1:(n_long-n_instante),]=fecha[(1+n_instante):n_long,]
			finmision[1:(n_long-n_instante),,]=finmision[(1+n_instante):n_long,,]
			femision[1:(n_long-n_instante),]=femision[(1+n_instante):n_long,]
			femisioncc[1:(n_long-n_instante),]=femisioncc[(1+n_instante):n_long,]
		# Datos y fechas perdidos (los hay cuando n_instante>1)
			if(n_instante>1){
				fechaP[(n_long-n_instante+1):(n_long-1)]=seq(fechaP[n_long-n_instante],fecha_nueva,by="5 min")[2:n_instante]
				inmi_real[(n_long-n_instante+1):(n_long-1),,]=rep(inmi_miss,each=n_instante-1)
				inmi_medH[(n_long-n_instante+1):(n_long-1),,]=rep(inmi_miss,each=n_instante-1)
				emi_real[(n_long-n_instante+1):(n_long-1),,]=rep(emi_miss,each=n_instante-1)
				emicc_real[(n_long-n_instante+1):(n_long-1),,]=rep(emicc_miss,each=n_instante-1)
				fecha[(n_long-n_instante+1):(n_long-1),]=formato(fechaPOSIX(fechaP[(n_long-n_instante+1):(n_long-1)],F),5)
				finmision[(n_long-n_instante+1):(n_long-1),1:(n_inm+6),]=rep(formato(c(inmi_miss,inmi_miss[1:6]),9,2),each=n_instante-1)
				femision[(n_long-n_instante+1):(n_long-1),]=rep(formato(emi_miss,9,2),each=n_instante-1)
				femisioncc[(n_long-n_instante+1):(n_long-1),]=rep(formato(emicc_miss,9,2),each=n_instante-1)}
		# ltimo instante, datos actual
			fechaP[n_long]=fecha_nueva
			inmi_real[n_long,,]=inmi_nuevo
			inmi_medH[n_long,,]=inmi_miss
			emi_real[n_long,,]=emi_nuevo
			emicc_real[n_long,,]=emicc_nuevo
			fecha[n_long,]=formato(fechaPOSIX(fechaP[n_long],F),5)
			finmision[n_long,1:n_inm,]=formato(inmi_nuevo,9,2)
			femision[n_long,]=formato(emi_nuevo,9,2)
			femisioncc[n_long,]=formato(emicc_nuevo,9,2)
		# calculo serie de medias
			n_datos=12		#12 datos cincominutales (60 datos minutales)
			for (j in (n_long-n_instante+1):n_long){ #instantes para los que se calcula la media
				aux=inmi_real[max(1,j-(n_datos-1)):j,,]	#los 12 datos minutales a tener en cuenta (si los hay)
				aux[aux==rep(inmi_miss,each=dim(aux)[1])]=NA
				aux=apply(aux,c(2,3),"mean",na.rm=T)
				aux[is.na(aux)]=rep(inmi_miss,n_est)[is.na(aux)]
				inmi_medH[j,,]=aux
				finmision[j,n_inm+1:2,]=formato(aux[1:2,],9,2)}
		# calcular periodos diarios y horarios
			periodo_fich=periodos(n_est,fechaP[n_long],inmi_real[n_long,1:6,],inmi_miss[1:6])
		# escribir fecha actual
			if (!file.exists(fecha_fich)) file.create(fecha_fich)
			cat(formato(fechaPOSIX(fecha_actual,F),5),sep="",fill=TRUE,file=fecha_fich)
		# escribir datos de inmisin
			# escribir "5min_*.dat" de cada estacin
			for (i in 1:n_est){
				fichero=paste(est_fich,est_nombre[i],".dat",sep="")
				if (!file.exists(fichero)) file.create(fichero)
				write.table(cbind(fecha,finmision[,,i]),file=fichero,quote=F,sep="",row.names=F)}
		# escribir datos de emisin de la central trmica
			# escribir "grupos.dat"
			if (!file.exists(emi_fich)) file.create(emi_fich)
			abrir=open_file(emi_fich,"w")
			write.table(cbind(fecha[1:n_long,],femision[,as.numeric(outer(ind_emi,n_emi*0:(n_grupo-1),"+"))]),file=abrir$con,quote=F,sep="",row.names=F)
			close(abrir$con)
		# escribir datos de emisin del ciclo combinado
			# escribir "gruposcc.dat"
			if (!file.exists(emicc_fich)) file.create(emicc_fich)
			abrir=open_file(emicc_fich,"w")
			write.table(cbind(fecha[1:n_long,],femisioncc[,as.numeric(outer(ind_emicc,n_emicc*0:(n_grupocc-1),"+"))]),file=abrir$con,quote=F,sep="",row.names=F)
			close(abrir$con)
		# copia los ficheros a los directorios necesarios		
			for (i in 1:n_dest){
				file.copy(from=periodo_fich,to=paste(dir_dest,periodo_fich,sep="/"),overwrite=T)}
		#----------------------------------------------------------------------------
		cat("(",round(difftime(Sys.time(),t0,units="secs"),4),"s )\n")
		flush.console()}	#hay datos nuevos
		#----------------------------------------------------------------------------
	}}
# --------------------------------------------------------------------------------- #
# --------------------------- Fin Bucle Infinito ---------------------------------- #
# --------------------------------------------------------------------------------- #
}
