# ------------------------------------------------------------ #
# --------- CLCULO DE PERIODOS HORARIOS Y DIARIOS ----------- #
# ---------- Escribe datos en fichero: prd_ddmmaa ------------ #
# -- Input: nest: n de estaciones 			    ---------- #
# --  fecha_act: fecha actual 			    ---------- #
# --  dat_act: SO2, NOx, CO, O3, PM10 y PM2.5 5min actuales  - #
# --  miss: valores missing de SO2, NOx, CO, O3, PM10 y PM2.5  #
# -- Output: fichero: nombre del fichero que crea   ---------- #
# ------------------------------------------------------------ #
periodos=function(nest,fecha_act,dat_act,miss){
	fichero=paste("prd",format(fecha_act,"%d%m.%y"),sep="_")	# nombre del fichero
	ind_ant=c(1:2,2+as.numeric(outer(0:2,seq(1,12*nest,12),"+")))
# Inicializar variables
	n_datos=0
	horas=c()
	dat_5min=array(miss,c(1,6,nest),dimnames=list(NULL,dimnames(dat_act)[[1]],dimnames(dat_act)[[2]]))
# Crear fichero (si no existe) o leer datos (si existe)
	if(!file.exists(fichero)){
		file.create(fichero)
		enc1=c(rep(formato("",3),2),rep(formato(dimnames(dat_act)[[2]],11),each=3*6))
		enc2=c(formato(c("H","M"),3),rep(formato(paste(c("5min_","pHor_","pDia_"),rep(c("SO2","NOx","CO","O3","PM10","PM2.5"),each=3),sep=""),11),nest))
		abrir=open_file(fichero,"w")
		cat(format(fecha_act,"  %d %m %Y"),"\n",enc1,"\n",enc2,"\n",sep="",file=abrir$con)
		close(abrir$con)}
	else{
		abrir=open_file(fichero,"r+")
		if (abrir$error) return(fichero)
		fecha_fich=scan(abrir$con,n=3,skip=0,nlines=1,quiet=T)
		if(all(fecha_fich==fechaPOSIX(fecha_act,F)[3:1])){ #lee datos anteriores
			aux=matrix(scan(abrir$con,skip=2,quiet=T),ncol=2+3*6*nest,byrow=T)
			close(abrir$con)
			n_datos=dim(aux)[1]	# n de datos en el fichero
 			horas=aux[,1]
			dat_5min=array(rep(miss,each=n_datos+1),c(n_datos+1,6,nest),dimnames(dat_5min))
			dat_5min[1:n_datos,,]=aux[,2+seq(1,3*6*nest,3)]}
		else{
			close(abrir$con)}}
# Actualizo valores
	horas[n_datos+1]=fecha_act$hour
	dat_5min[n_datos+1,,]=dat_act
# Calculo medias
	dat_5min[dat_5min==rep(miss,each=n_datos+1)]=NA
	if (n_datos==0){
	#media periodo diario
		periodo_diario=dat_act
	#media periodo horario
		periodo_horario=dat_act}
	else{
	#media periodo diario
		periodo_diario=apply(dat_5min,c(2,3),"mean",na.rm=T)
		periodo_diario[is.na(periodo_diario)]=rep(miss,nest)[is.na(periodo_diario)]
	#media periodo horario
		periodo_horario=apply(array(dat_5min[which(horas==horas[n_datos+1]),,],c(sum(horas==horas[n_datos+1]),6,nest)),c(2,3),"mean",na.rm=T)
		periodo_horario[is.na(periodo_horario)]=rep(miss,nest)[is.na(periodo_horario)]}
# Escribe fichero diario con los datos
	aux=c(formato(c(fecha_act$hour,fecha_act$min),3),formato(as.numeric(rbind(as.numeric(dat_act),
			as.numeric(periodo_horario),as.numeric(periodo_diario))),11,2))
	cat(aux,"\n",sep="",file=fichero,append=T)
	return(fichero)}
