# ---------------------------------------------------------------------- #
# -------------- PROGRAMA QUE CALCULA LA MEDIA BIDIARIA ---------------- #
# --------------       DEL PERIODO PAI                  ---------------- #
# ---------------------------------------------------------------------- #
pai=function(directorio){

    t0=Sys.time()
    miss=-1
    fecha_inicio=list()
    fecha_fin=list()
    fecha_inicio_ant=list()        
    var_nombre=c("SO2","NOx","Par")
    cat(rep("-",54),"\n\tClculo del valor medio bidiario (PAI)\n",rep("-",54),"\n",sep="")
    setwd(paste(directorio,"programas/x_nl/fechaPAI_central",sep="/"))
    
    # Leer fecha de comienzo del ltimo periodo PAI
    for (i in 1:3){
        fichero=paste("fechaPAI_",var_nombre[i],".dat",sep="")
        if (!file.exists(fichero)) stop("No existe el fichero", fichero,"\n")
        fecha_inicio[[i]]=strptime(paste(scan(fichero,what="",n=2,skip=1,nlines=1,quiet=T),collapse=" "),"%d/%m/%Y %H:%M")
        if (is.na(fecha_inicio[[i]])) stop("No se ha encontrado una fecha vlida en el fichero", fichero)
        # Escribir fecha inicio en pantalla y en fechaPAI.dat
    cat("FECHA INICIO PERIODO ACTUAL ",var_nombre[i],":\t",format(fecha_inicio[[i]],"%d/%m/%y %H:%M"),
     "\n********************************************************\n",sep="")
    cat("Fecha de inicio del ltimo periodo de 48 horas PAI\n\t",format(fecha_inicio[[i]],"%d/%m/%Y %H:%M"),file=fichero)} 
    
# Valores iniciales
    paiN=rep(0,3)                       #Datos cincominutales de potencia >200 de una hora.
    paiSuma=rep(0,3)                    # Emisin ponderada por la carga.
    names(paiSuma)=formato(var_nombre,9)
    pai_ant=rep(0,3)                    # Media de emisin del periodo Pai anterior.
    names(pai_ant)=formato(var_nombre,9)
    pai_horario=rep(0,3)                # Emisin horaria. Sumamos la media de emisin de las 48 horas que corresponden al periodo PAI correspondiente. 
    names(pai_horario)=formato(var_nombre,9)
    pai=rep(0,3)                        # Emisin horaria. Sumamos la media de emisin de los pentaminutales que pertenecen a la hora correspondiente.
    names(pai)=formato(var_nombre,9)
    inicio=c(TRUE,TRUE,TRUE)
    nuevo=c(TRUE,TRUE,TRUE)
    horas=rep(0,3)                       # Cuenta la horas que entran en el periodo PAI.
    Mdatos=rep(0,3)
    Mday=rep(0,3)
    Mmon=rep(0,3)
    Myear=rep(0,3)
    fecha_ult=fecha_inicio
    
    # fecha_ult fecha de inicio menos cinco minutos
    for (i in 1:3){fecha_ult[[i]]$min=fecha_ult[[i]]$min-5}   
    
    # Recuperar datos de los ficheros pai*.dat (si es posible)
    setwd(paste(directorio,"programas/x_nl",sep="/"))
    for (i in 1:3){
        fichero_pai=paste("pai_",var_nombre[i],".dat",sep="")
        abrir=open_file(fichero_pai,"r+")
        if(!abrir$error){
            aux=scan(abrir$con,what="",n=8,skip=0,nlines=1,quiet=T)
            fecha_inicio_ant[[i]]=strptime(paste(aux[7],aux[8]),"%d/%m/%Y %H:%M")
            if(fecha_inicio_ant[[i]]<=fecha_inicio[[i]]){
                pai_ant[i]=scan(abrir$con,what=list(NULL,double(0)),n=2,sep=":",skip=0,nlines=1,quiet=T)[[2]]
                aux=scan(abrir$con,n=576*9,skip=1,nlines=576,quiet=T)
                paiN[i]=aux[length(aux)-7]
                pai_horario[i]=aux[length(aux)-1]
                horas[i]=aux[length(aux)]
                paiSuma[i]=((aux[length(aux)-8]*(horas[i]+1))-pai_horario[i])*paiN[i]
                nuevo[i]=FALSE
                fecha_ult[[i]]=fechaPOSIX(aux[length(aux)-6:2])
                Mdatos[i]=fecha_ult[[i]]$hour
                Mday[i]=fecha_ult[[i]]$mday
                Mmon[i]=fecha_ult[[i]]$mon+1
                Myear[i]=fecha_ult[[i]]$year+1900}
            # fecha_ult ltimo dato cinco minutal con potencia>200.
            close(abrir$con)}} 
    

    cat("Lectura de datos iniciales (",round(difftime(Sys.time(),t0,units="secs"),3),"s )\n")
    flush.console()
# Guardar fechas de inicio
    fecha_inicio_ant=fecha_inicio
    
# ------------------------------------------------------------
# Bucle de clculo continuo
# ------------------------------------------------------------
while (TRUE){
# Coger fecha actual del fichero grupos.dat
    abrir=open_file("grupos.dat","r+")
    if(!abrir$error) {
        aux=scan(abrir$con,n=5,skip=48,nlines=1,quiet=T)
        close(abrir$con)
        if(length(aux)==5){
            fecha_act=fechaPOSIX(aux) # Fecha en el instante actual
            cat("Esperando datos nuevos...\n")                      
            for (i in 1:3){
        # Si hay datos nuevos
                if(fecha_act>fecha_ult[[i]]){
                    cat("\tCalculando para ",var_nombre[i],"...")
                    t0=Sys.time()
                    instantes=min(as.numeric(difftime(fecha_act,fecha_ult[[i]],units="mins"))/5,48)
                    abrir=open_file("grupos.dat","r+")
                    if (!abrir$error) {
                        aux=scan(abrir$con,n=instantes*(5+16),skip=49-instantes,nlines=instantes,quiet=T)
                        close(abrir$con)
                        if (length(aux)==instantes*(5+16)){
                            aux=matrix(aux,instantes,5+16,byrow=T)
                            ind=which(fechaPOSIX(aux[,1:5])>=fecha_inicio[[i]])
                            instantes=length(ind)   
                            aux=matrix(aux[ind,],instantes,5+16)
                            fechas=matrix(aux[,1:5],instantes,5,dimnames=list(NULL,
                                c("Ao","Mes","Da","Hora","Min")))
                            aux=array(aux[,-(1:5)],c(instantes,4,4),dimnames=list(NULL,c("SO2","NOx",
                                "Part","Pot"),c("Grupo  I","Grupo II","GrupoIII","Grupo IV")))
                            aux[aux==miss]=NA
                            var=matrix(aux[,i,],nrow=instantes,dimnames=list(NULL,dimnames(aux)[[3]]))
                            Pot=matrix(aux[,4,],nrow=instantes,dimnames=list(NULL,dimnames(aux)[[3]]))
                            Potencia=Pot
                            Pot[Pot<=200|is.na(var)]=NA
                            ## Calculo el total central, ponderando por la potencia.
                            TotalC=apply(var*Pot,1,sum,na.rm=T)/apply(Pot,1,sum,na.rm=T)
                            TotalC[TotalC==0]=NA
                            ## Bucle para cada instante.
                            for (j in 1:instantes){
                            
                            if(any(Potencia[j,]>200,na.rm=TRUE)){
                            fichero_pai=paste("pai_",var_nombre[i],".dat",sep="")
                            abrir=open_file(fichero_pai,"r+")   
                            if(!abrir$error){                 
                            ## Se Cuentan las horas Pai contabilizadas.
                            auxiliar=matrix(scan(abrir$con,what="",skip=3,quiet=T),nrow=9)
                            close(abrir$con)

                            Mdatos[i]<-auxiliar[6,][length(auxiliar[6,])] ## Leemos las horas del fichero Pai.
                            Mday[i]<-auxiliar[5,][length(auxiliar[5,])]   ## Leemos los das del fichero Pai.
                            Mmon[i]<-auxiliar[4,][length(auxiliar[4,])]   ## Leemos los meses del fichero Pai.
                            Myear[i]<-auxiliar[3,][length(auxiliar[3,])]  ## Leemos los aos del fichero Pai.
                            
                            
                            ## Cuntas horas son distintas?.
                            #horas[i]=length(rle(Mdatos)$values) 
                        
                            ## La hora actual forma parte del periodo PAI.

                            ## Despus de una parada debemos comprobar si estamos en el mismo da.
                            ## 1.- Estamos en el mismo da.
                            if((fechaPOSIX(fechas[j,])$mon+1==as.numeric(Mmon[i]))&(fechaPOSIX(fechas[j,])$mday==as.numeric(Mday[i]))){
                            ## Si estamos en el mismo da...
                            
                            ## Contabilizamos una hora ms en el periodo PAI
                            if(fechaPOSIX(fechas[j,])$hour>as.numeric(Mdatos[i])){ 
                                horas[i]=horas[i]+1
                                ## Media horaria de la hora anterior.
                                pai_horario[i]= pai_horario[i]+pai[i]
                                paiN[i]=ifelse(is.na(TotalC[j]),0,1)
                                paiSuma[i]=ifelse(is.na(TotalC[j]),0,TotalC[j])
                                pai[i]=ifelse(is.na(paiSuma[i]/paiN[i]),0,paiSuma[i]/paiN[i])}
                                
                            ## No contabilizamos una hora ms en el periodo PAI.
                            if(fechaPOSIX(fechas[j,])$hour==as.numeric(Mdatos[i])){ 
                            ## Comprobar si es dato missing o no y obtener la media horaria.
                            if(!is.na(TotalC[j])){ 
                                    paiN[i]=paiN[i]+1
                                    paiSuma[i]=paiSuma[i]+TotalC[j]}
                                    pai[i]=ifelse(is.na(paiSuma[i]/paiN[i]),0,paiSuma[i]/paiN[i])}
                            }
                            ## 2.- Estamos en das distintos.
                            else{
                                horas[i]=horas[i]+1
                                ## Media horaria de la ltima hora clculada
                                pai_horario[i]= pai_horario[i]+pai[i]
                                paiN[i]=ifelse(is.na(TotalC[j]),0,1)
                                paiSuma[i]=ifelse(is.na(TotalC[j]),0,TotalC[j])
                                pai[i]=ifelse(is.na(paiSuma[i]/paiN[i]),0,paiSuma[i]/paiN[i])}
                            
                            }
                            
                            ## Si no se puede abrir el ficheros pai*.dat
                            else{
                            if(!is.na(TotalC[j])){ 
                                    paiN[i]=paiN[i]+1
                                    paiSuma[i]=paiSuma[i]+TotalC[j]}   
                                    pai[i]=ifelse(is.na(paiSuma[i]/paiN[i]),0,paiSuma[i]/paiN[i])}
                            
                            # Comprobar si es final de periodo (completado periodo bidiario o cambio de ao)
                                 if (horas[i]==48|fechaPOSIX(fechas[j,])$year>fecha_inicio[[i]]$year){
                                    pai_ant[i]=pai_horario[i]/48   # guarda la media del periodo anterior
                                    pai_horario[i]=0
                                    horas[i]=0
                                    nuevo[i]=TRUE
                                    fecha_inicio[[i]]=fechaPOSIX(fechas[j,])
                                    fecha_inicio[[i]]$min=0
                                    }
                                    
                                else{
                                    nuevo[i]=inicio[i]*nuevo[i]}
                            
                            # Si el fichero no existe o periodo nuevo
                                fichero_pai=paste("pai_",var_nombre[i],".dat",sep="")
                                if (!file.exists(fichero_pai)|nuevo[i]){
                                # si comienza periodo
                                    if(horas[i]==0){
                                        if(!inicio[i]){     
                                            fecha_inicio[[i]]=fechaPOSIX(fechas[j,])
                                            fecha_inicio[[i]]$min=0}
                                        else{
                                            inicio[i]=FALSE}}
                                            
                                # creo y escribo el fichero
                                    if (!file.exists(fichero_pai)) file.create(fichero_pai)
                                    abrir=open_file(fichero_pai,"w")
                                    cat("  Fecha de inicio del PAI ", var_nombre[i],":\t",format(fecha_inicio[[i]],"%d/%m/%Y %H:%M"),sep="",fill=T,file=abrir$con)
                                    cat("  Media PAI anterior: ",formato(pai_ant[i],8,0),sep="",fill=T,file=abrir$con)
                                    cat("      PAI","  N ",sep="",fill=T,file=abrir$con)
                                    close(abrir$con)}
                                    
                            # Escribir el fichero con los datos del periodo PAI
                                abrir=open_file(fichero_pai,"a")
                                cat(formato(((pai_horario[i]+pai[i])/(horas[i]+1)),9),formato(paiN[i],4),formato(fechas[j,],5),formato(pai_horario[i],9),formato(horas[i],4),sep="",fill=T,file=abrir$con)
                                close(abrir$con)
                        # Escribir fecha inicio y fecha fin en pantalla y en fechaPAI.dat (si se han modificado)
                            if (fecha_inicio[[i]]!=fecha_inicio_ant[[i]]){
                                setwd(paste(directorio,"programas/x_nl/fechaPAI_central",sep="/"))
                                fichero=paste("fechaPAI_",var_nombre[i],".dat",sep="")
                                cat("FECHA INICIO PERIODO ACTUAL ",var_nombre[i],":\t",format(fecha_inicio[[i]],"%d/%m/%y %H:%M"),
                                    "\n********************************************************\n",sep="")
                                cat("Fecha de inicio del ltimo periodo de 48 horas PAI\n\t",format(fecha_inicio[[i]],"%d/%m/%Y %H:%M"),file=fichero)  
                                fecha_inicio_ant[[i]]=fecha_inicio[[i]]
                                
                                setwd(paste(directorio,"programas/x_nl",sep="/"))}
                            flush.console()}}}}
                fecha_ult[[i]]=fecha_act    
                file.copy(from=fichero_pai,to="../../prediccion_NL",overwrite=T)
                flush.console()
                cat("(",round(difftime(Sys.time(),t0,units="secs"),3),"s )\n")
                cat("\tpara fecha",format(fecha_act,"%d/%m/%y %H:%M "),"\n")}}}}
    Sys.sleep(150)}
# -----------------------------
# Fin bucle de clculo continuo
# -----------------------------
}
