# ---------------------------------------------------------------------- #
# -------------- PROGRAMA QUE CALCULA LA MEDIA DIARIA ------------------ #
# --------------           DEL PERIODO PAI            ------------------ #
# ---------------------------------------------------------------------- #
pai=function(directorio){
    t0=Sys.time()
    miss=-1
    fecha_inicio=list(TGI=list(),TGII=list())
    fecha_fin=list(TGI=list(),TGII=list())
    fecha_inicio_ant=list(TGI=list(),TGII=list())
    fecha_fin_ant=list(TGI=list(),TGII=list())
    var_nombre=c("SO2","NOx","Par")
    grup=c("TGI","TGII")
    cat(rep("-",54),"\n\tClculo del valor medio diario (PAI)\n",rep("-",54),"\n",sep="")
    setwd(paste(directorio,"programas/x_nl/fechaPAI_ciclo",sep="/"))
# Leer fecha de comienzo del ltimo periodo PAI
    for (i in 1:3){
        for (k in 1:2){
            fichero=paste("fechaPAI_",var_nombre[i],"_",grup[k],".dat",sep="")
            if (!file.exists(fichero)) stop("No existe el fichero", fichero,"\n")
            fecha_inicio[[k]][[i]]=strptime(paste(scan(fichero,what="",n=2,skip=1,nlines=1,quiet=T),collapse=" "),"%d/%m/%Y %H:%M")
            if (is.na(fecha_inicio[[k]][[i]])) stop("No se ha encontrado una fecha vlida en el fichero", fichero)
            fecha_fin[[k]][[i]]=strptime(paste(scan(fichero,what="",n=2,skip=3,nlines=1,quiet=T),collapse=" "),"%d/%m/%Y %H:%M")        
    # Calculo el instante final para este periodo
            if (is.na(fecha_fin[[k]][[i]])|fecha_fin[[k]][[i]]<fecha_inicio[[k]][[i]]){
                cat("Fecha de fin de periodo ausente o no vlida en",fichero,fill=T)
                fecha_fin[[k]][[i]]=fecha_inicio[[k]][[i]]
                fecha_fin[[k]][[i]]$min=fecha_fin[[k]][[i]]$min+287*5}  #con el instante en el que est, son 288
            if (difftime(fecha_fin[[k]][[i]],fecha_inicio[[k]][[i]],units="min")/5!=287){
                cat("Con las fechas introducidas en",fichero,"el periodo PAI no es de 24 horas",fill=T)}
    # Escribir fecha inicio y fecha fin en pantalla
        cat("FECHA INICIO PERIODO ACTUAL ",var_nombre[i],"_",grup[k],":\t",format(fecha_inicio[[k]][[i]],"%d/%m/%y %H:%M"),
            "\nFecha fin periodo actual ",var_nombre[i],"_",grup[k],":\t\t",format(fecha_fin[[k]][[i]],"%d/%m/%y %H:%M"),
            "\n********************************************************\n",sep="")
        cat("Fecha de inicio del ltimo periodo de 24 horas PAI\n\t",format(fecha_inicio[[k]][[i]],"%d/%m/%Y %H:%M"),
            "\nFecha fin periodo actual\n\t",format(fecha_fin[[k]][[i]],"%d/%m/%Y %H:%M"),file=fichero)}}
# Valores iniciales
    paiN=matrix(rep(0,6),2,3)
    paiSuma=matrix(rep(0,6),2,3)
    dimnames(paiSuma)=list(formato(c("TGI","TGII"),9),formato(c("SO2","NOx","Par"),9))
    pai_ant=matrix(rep(0,6),2,3)
    dimnames(pai_ant)=list(formato(c("TGI","TGII"),9),formato(c("SO2","NOx","Par"),9))
    pai=matrix(rep(0,6),2,3)
    dimnames(pai)=list(formato(c("TGI","TGII"),9),formato(c("SO2","NOx","Par"),9))
    inicio=matrix(rep(TRUE,6),2,3)
    nuevo=matrix(rep(TRUE,6),2,3)
    eliminados=matrix(rep(0,6),2,3)
    fecha_ult=fecha_inicio
    for (i in 1:3){
        for (k in 1:2) {fecha_ult[[k]][[i]]$min=fecha_ult[[k]][[i]]$min-5}}
# Recuperar datos de los ficheros pai*.dat (si es posible)
    setwd(paste(directorio,"programas/x_nl",sep="/"))
    for (i in 1:3){
        for (k in 1:2){
            fichero_pai=paste("pai_",var_nombre[i],"_",grup[k],".dat",sep="")
            abrir=open_file(fichero_pai,"r+")
            if(!abrir$error){
                aux=scan(abrir$con,what="",n=8,skip=0,nlines=1,quiet=T)
                fecha_inicio_ant[[k]][[i]]=strptime(paste(aux[7],aux[8]),"%d/%m/%Y %H:%M")
                if(fecha_inicio_ant[[k]][[i]]<=fecha_inicio[[k]][[i]]){
                    pai_ant[k,i]=scan(abrir$con,what=list(NULL,double(0)),n=2,sep=":",skip=0,nlines=1,quiet=T)[[2]]
                    aux=scan(abrir$con,n=288*7,skip=1,nlines=288,quiet=T)
                    if(fecha_inicio_ant[[k]][[i]]==fecha_inicio[[k]][[i]]){
                        paiN[k,i]=aux[length(aux)-5]
                        paiSuma[k,i]=aux[length(aux)-6]*aux[length(aux)-5]
                        nuevo[k,i]=FALSE
                        fecha_ult[[k]][[i]]=fechaPOSIX(aux[length(aux)-4:0])}}
                close(abrir$con)}}}
    cat("Lectura de datos iniciales (",round(difftime(Sys.time(),t0,units="secs"),3),"s )\n")
    flush.console()
# Guardar fechas de inicio y fin
    fecha_inicio_ant=fecha_inicio
    fecha_fin_ant=fecha_fin
# ------------------------------------------------------------
# Bucle de clculo continuo
# ------------------------------------------------------------
while (TRUE){
# Coger fecha actual del fichero grupos.dat
    abrir=open_file("gruposcc.dat","r+")
    if(!abrir$error) {
        aux=scan(abrir$con,n=5,skip=48,nlines=1,quiet=T)
        close(abrir$con)
        if(length(aux)==5){
            fecha_act=fechaPOSIX(aux)
            cat("Esperando datos nuevos...\n")          
            for (i in 1:3){
                for (k in 1:2){
        # Si hay datos nuevos
                if(fecha_act>fecha_ult[[k]][[i]]){
                    cat("\tCalculando para ",var_nombre[i],"_",grup[k],"...")
                    t0=Sys.time()
                    instantes=min(as.numeric(difftime(fecha_act,fecha_ult[[k]][[i]],units="mins"))/5,48)
                    abrir=open_file("gruposcc.dat","r+")
                    if (!abrir$error) {
                        aux=scan(abrir$con,n=instantes*(5+8),skip=49-instantes,nlines=instantes,quiet=T)
                        close(abrir$con)
                        if (length(aux)==instantes*(5+8)){
                            aux=matrix(aux,instantes,5+8,byrow=T)
                            ind=which(fechaPOSIX(aux[,1:5])>=fecha_inicio[[k]][[i]])
                            instantes=length(ind)   
                            aux=matrix(aux[ind,],instantes,5+8)
                            fechas=matrix(aux[,1:5],instantes,5,dimnames=list(NULL,
                                c("Ao","Mes","Da","Hora","Min")))
                            aux=array(aux[,-(1:5)],c(instantes,4,2),dimnames=list(NULL,c("SO2","NOx",
                                "Part","Pot"),c("Foco  I","Foco II")))
                            aux[aux==miss]=NA
                            var_emi=matrix(aux[,i,k],nrow=instantes,dimnames=list(NULL,dimnames(aux)[[3]][k]))
                            Pot=matrix(aux[,4,k],nrow=instantes,dimnames=list(NULL,dimnames(aux)[[3]][k]))
                            Pot[Pot<=190|is.na(var_emi)]=NA
#                           paiSuma[k,i]=sum(var_emi)
                        #Bucle para cada dato
                            for (j in 1:instantes){                                 
                            # Comprobar si es final de periodo (completado periodo diario o cambio de ao)
                                if (fecha_fin[[k]][[i]]<fechaPOSIX(fechas[j,])|fechaPOSIX(fechas[j,])$year>fecha_ult[[k]][[i]]$year){
                                    pai_ant[k,i]=pai[k,i]   # guarda la media del periodo anterior
                                    paiN[k,i]=0
                                    paiSuma[k,i]=0
                                    nuevo[k,i]=TRUE
                                    fecha_inicio[[k]][[i]]=fechaPOSIX(fechas[j,])
                                    fecha_inicio[[k]][[i]]$hour=0
                                    fecha_inicio[[k]][[i]]$min=0
                                    fecha_fin[[k]][[i]]=fecha_inicio[[k]][[i]]
                                    fecha_fin[[k]][[i]]$min=fecha_fin[[k]][[i]]$min+287*5}  #con el instante en el que est, son 288
                                else{
                                    nuevo[k,i]=inicio[k,i]*nuevo[k,i]}
                            # Para el Ciclo Combinado no se cambia el periodo si faltan datos. Son siempre valores medios diarios.
                            # Comprobar si es dato missing o no
                                if(!is.na(var_emi[j])){
                                    eliminados[k,i]=0   
                                    paiN[k,i]=paiN[k,i]+1
                                    paiSuma[k,i]=paiSuma[k,i]+var_emi[j]}
#                               else{
#                                   if((eliminados[k,i]==0)&(fecha_act$min<5)) eliminados[k,i]=1    # empieza hora natural
#                                   if(eliminados[k,i]>0) eliminados[k,i]=eliminados[k,i]+1
#                                   if(eliminados[k,i]>11){ #no cuenta la hora para el PAI
#                                       eliminados[k,i]=0
#                                       fecha_fin[[k]][[i]]$hour=fecha_fin[[k]][[i]]$hour+1}}
                                pai[k,i]=ifelse(is.na(paiSuma[k,i]/paiN[k,i]),0,paiSuma[k,i]/paiN[k,i])
                            # Si el fichero no existe o periodo nuevo
                                fichero_pai=paste("pai_",var_nombre[i],"_",grup[k],".dat",sep="")
                                if (!file.exists(fichero_pai)|nuevo[i]){
                                # si comienza periodo
                                    if(paiN[k,i]==1){
                                        if(!inicio[k,i]){       
                                            fecha_inicio[[k]][[i]]=fechaPOSIX(fechas[j,])
                                            fecha_inicio[[k]][[i]]$hour=0
                                            fecha_inicio[[k]][[i]]$min=0}
                                        else{
                                            inicio[k,i]=FALSE}
                                        fecha_fin[[k]][[i]]=fecha_inicio[[k]][[i]]
                                        fecha_fin[[k]][[i]]$min=fecha_fin[[k]][[i]]$min+287*5}  #instante final para este periodo
                                # creo y escribo el fichero
                                    if (!file.exists(fichero_pai)) file.create(fichero_pai)
                                    abrir=open_file(fichero_pai,"w")
                                    cat("  Fecha de inicio del PAI ", var_nombre[i],":\t",format(fecha_inicio[[k]][[i]],"%d/%m/%Y %H:%M"),sep="",fill=T,file=abrir$con)
                                    cat("  Media PAI anterior: ",formato(pai_ant[k,i],8,0),sep="",fill=T,file=abrir$con)
                                    cat("      PAI","  N ",sep="",fill=T,file=abrir$con)
                                    close(abrir$con)}
                            # Escribir el fichero con los datos del periodo PAI
                                abrir=open_file(fichero_pai,"a+")
                                cat(formato(pai[k,i],9),formato(paiN[k,i],4),formato(fechas[j,],5),sep="",fill=T,file=abrir$con)
                                close(abrir$con)
                            # Escribir fecha inicio y fecha fin en pantalla y en fechaPAI.dat (si se han modificado)
                                if (fecha_inicio[[k]][[i]]!=fecha_inicio_ant[[k]][[i]]|fecha_fin[[k]][[i]]!=fecha_fin_ant[[k]][[i]]){
                                    setwd(paste(directorio,"programas/x_nl/fechaPAI_ciclo",sep="/"))
                                    fichero=paste("fechaPAI_",var_nombre[i],"_",grup[k],".dat",sep="")
                                    cat("FECHA INICIO PERIODO ACTUAL ",var_nombre[i],"_",grup[k],":\t",format(fecha_inicio[[k]][[i]],"%d/%m/%y %H:%M"),
                                        "\nFecha fin periodo actual ",var_nombre[i],"_",grup[k],":\t\t",format(fecha_fin[[k]][[i]],"%d/%m/%y %H:%M"),
                                        "\n********************************************************\n",sep="")
                                    cat("Fecha de inicio del ltimo periodo de 24 horas PAI\n\t",format(fecha_inicio[[k]][[i]],"%d/%m/%Y %H:%M"),
                                    "\nFecha fin periodo actual\n\t",format(fecha_fin[[k]][[i]],"%d/%m/%Y %H:%M"),file=fichero) 
                                    fecha_inicio_ant[[k]][[i]]=fecha_inicio[[k]][[i]]
                                    fecha_fin_ant[[k]][[i]]=fecha_fin[[k]][[i]]
                                    setwd(paste(directorio,"programas/x_nl",sep="/"))}
                                flush.console()}}}
                    fecha_ult[[k]][[i]]=fecha_act   
                    file.copy(from=fichero_pai,to="../../prediccion_NL",overwrite=T)
                    flush.console()
                    cat("(",round(difftime(Sys.time(),t0,units="secs"),3),"s )\n")
                    cat("\tpara fecha",format(fecha_act,"%d/%m/%y %H:%M "),"\n")}}}}}
        Sys.sleep(150)}
# -----------------------------
# Fin bucle de clculo continuo
# -----------------------------
}
